#include "aloha.h"

Aloha::Aloha()
{
  cout<<"Cannot use default constructor for Aloha!"<<endl;
  exit(-1);
}

Aloha::~Aloha() 
{
}

Aloha::Aloha(long p_i, struct Medium_Link * p_m, 
	     double p_a, long p_p):
  my_id(p_i),
  my_medium(p_m),
  arr_rate(p_a),
  mean_pkt_size(p_p),
  transmitting(false)
{
  new Exp_Pack_Gen(this, p_a, p_p);
}

void Aloha::Packet_to_transmit(long p_p)
{
  if(!transmitting)
    {
      my_medium->Transmission_Starts(p_p, my_id);
      transmitting=true;
    }
  else
    {
      my_buffer.push_back(p_p);
    }
}

void Aloha::Packet_transmission_over()
{
  transmitting=false;
  if(my_buffer.size())
    {
      transmitting=true;
      my_medium->Transmission_Starts(my_buffer[0], my_id);
      my_buffer.erase(my_buffer.begin(),my_buffer.begin()+1);
    }

}

void Aloha::Incoming_packet(long from_id, long p_bytes)
{
  /* cout<<"Station:"<<my_id<<" received a "<<p_bytes
     <<"bytes long packet at:"<<Simengine().SimTime()<<
     <<" from node:"<<from_id<<endl;*/
}
