
#include "global.h"
#include "simengine.h"
#include "medium_link.h"

#include <iostream>
#include <cmath>

using namespace std;

int main(int c, char** v) 
{
  struct Medium_Link * ml;
  if(c!=7)
    {
      cout<<"usage: "<<v[0]<<" simtime(in secs)  seed  arr_rate  mean_pkt_size  station_population channel_speed(bps)"<<endl;
      exit(-1);
    }
  
  ml = new struct Medium_Link(atoi(v[5]),atof(v[6]),atof(v[3]),
			      atoi(v[4]) );
  Rangen.initStream(atoi(v[2]));  
  Simengine().Simulate(atof(v[1])); 
  cout<<endl<<"Channel Bandwith:"<<atof(v[6])<<"bps"<<endl
      <<"Calculated Load:"<<atof(v[3])*atoi(v[5])*8.0*atoi(v[4])<<"bps"<<" ("
      <<100.0*atof(v[3])*atoi(v[5])*8.0*atoi(v[4])/atof(v[6])<<"%)"<<endl
      <<"Measured Load:"<<8.0*ml->Accum_Load()/atof(v[1])<<"bps"<<" ("
      <<100.0*8.0*ml->Accum_Load()/(atof(v[1])*atof(v[6]))<<"%)"<<endl
 
     <<"Throughput:"<<8.0*ml->Successes()/atof(v[1])<<"bps"<<endl
      <<"Useful Utilization:"
      <<100.0*8.0*ml->Successes()/(atof(v[1])*atof(v[6]))
      <<"%"<<endl;
}
 
