
#ifndef _ALOHA_H_
#define _ALOHA_H_

#include "global.h"
#include "simengine.h"
#include "medium_link.h"
#include "exp_packet_gen.h"

class Aloha
{
 public:
  Aloha();
  Aloha(long, struct Medium_Link *, double, long);
  ~Aloha();
  void Packet_to_transmit(long);
  void Incoming_packet(long,long);
  void Packet_transmission_over();

private:
  long my_id;
  struct Medium_Link * my_medium;
  double arr_rate;
  long mean_pkt_size;
  vector <long> my_buffer;
  char transmitting;
};

#endif







